/*
 * random.c:
 * Obtain random data from /dev/urandom.
 *
 * Copyright (c) 2001 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 */

static const char rcsid[] = "$Id: random.c,v 1.1.1.1 2001/08/30 18:24:39 chris Exp $";

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <syslog.h>
#include <unistd.h>

#include "vpn-udp.h"

/* File descriptor on /dev/urandom. */
int fd_random;

/* setup_random_data:
 * Open /dev/urandom. */
int setup_random_data(void) {
    fd_random = open("/dev/urandom", O_RDONLY);
    if (fd_random == -1) {
        print_log(LOG_ERR, "open(`/dev/urandom'): %m");
        return 0;
    }
    return 1;
}

/* get_random_data:
 * Get some random data. */
int get_random_data(unsigned char *buf, int len) {
    ssize_t n = read(fd_random, buf, len);
    if (n == -1) {
        print_log(LOG_ERR, "read(`/dev/urandom'): %m");
        return 0;
    }
    /* XXX assume success */
    return 1;
}
