/*
 * vpn-udp.h:
 * Project header file.
 *
 * Copyright (c) 2001 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 * $Id: vpn-udp.h,v 1.1.1.1 2001/08/30 18:24:39 chris Exp $
 *
 */

#ifndef __VPN_UDP_H_ /* include guard */
#define __VPN_UDP_H_

/* Name of program, for diagnostic messages. */
#define PROGNAME    "vpn-udp"

/* Buffer length, larger than any network packet. */
#define BUFLEN      8192


/* encryption.c */
int setup_encryption(char *file);
void encrypt_packet(unsigned char *packet, int length);
void decrypt_packet(unsigned char *packet, int length);
/* if.c */
int create_interface(void);
int write_to_if(unsigned char *pkt, int length);
int read_from_if(void);
/* logprint.c */
void print_log(int priority, const char *fmt, ...);
/* main.c */
void usage(FILE *fp);
/* random.c */
int setup_random_data(void);
int get_random_data(unsigned char *buf, int len);
/* tunnel.c */
int connect_to_remote(void);
int write_to_tunnel(unsigned char *packet, int length);
int read_from_tunnel(void);

#endif /* __VPN_UDP_H_ */
